package com.persagy.proxy.adm.strategy.relationdata;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.proxy.adm.model.AdmRelationObject;

/**
 * 
 * @version 1.0.0
 * @company persagy 
 * @author zhangqiankun
 * @date 2021年9月2日 下午10:46:03
 */
public interface QueryRelationObjectStrategy {

	String WHERE_IN = "$in";
	
	String OBJ_TYPE = "objType";
	
	Map<String, String> OBJNAME_2_TYPE = new HashMap<String,String>(){
		private static final long serialVersionUID = 1L;
		{
            put("对象ID", "id");
            put("对象名称", "name");
            put("对象本地编码", "local_id");
            put("对象本地名称", "local_name");
            put("设计图纸中编码", "cad_id");
        }
    };
    
	/**
	 * 查询出所有的关系信息
	 * 
	 * @param groupCode 集团编码
	 * @param projectId 项目ID
	 * @return 不会返回null
	 */
	List<AdmRelationObject> findRelationObject(String groupCode, String projectId);
	
	/**
	 * 保存之前校验数据的合法性
	 * 
	 * @param objectNode 校验通过后为其赋予必要的值
	 * @param relationObject 需要校验的对象
	 * @param groupCode
	 * @param projectId
	 * @param code 参考 OBJNAME_2_TYPE
	 * @return null - 校验通过，否则-失败原因
	 */
	String beforeSaveRelationObject(ObjectNode objectNode, AdmRelationObject relationObject, String groupCode, String projectId, String code);

	/**
	 * 批量保存对象之间的关系
	 * 
	 * @param admRelationObject
	 * @param groupCode
	 * @param projectId
	 * @return 
	 */
	boolean saveRelationObjects(List<ObjectNode> relationObjects, String groupCode, String projectId);

}
